package org.netkernel.client.ftp.representation;

import java.io.IOException;
import java.net.URI;
import org.netkernel.layer0.nkf.INKFExpiryFunction;
import com.enterprisedt.net.ftp.FTPException;
import com.enterprisedt.net.ftp.FileTransferClient;

public class FTPConnectionRepresentation implements INKFExpiryFunction
{
	private final FileTransferClient mClient;
	private boolean mInvalid;
	
	public FTPConnectionRepresentation(String aConnectionString) throws IOException, FTPException
	{	
		URI uri=URI.create(aConnectionString);
		String host=uri.getHost();
		int port=uri.getPort();
		if (port==-1) port=21;
		String username="anonymous";
		String password="netkernel@1060research.com";
		String userInfo=uri.getUserInfo();
		if (userInfo!=null)
		{	String[] result = userInfo.split(":");
			if (result.length>0)
			{	username=result[0];
				if (result.length>1)
				{	password=result[1];
				}
			}
		}
		
		FileTransferClient ftpClient = new FileTransferClient();
		ftpClient.getAdvancedSettings().setAutoLogin(false);
		
		ftpClient.setRemoteHost(host);
		ftpClient.setRemotePort(port);
		ftpClient.setUserName(username);
		ftpClient.setPassword(password);
		ftpClient.connect();
		ftpClient.manualLogin();
		mClient=ftpClient;
	}

	public boolean isExpired(long aNow)
	{	return !mInvalid && mClient.isConnected();
	}
	
	protected void finalize()
	{	innerCleanup();
	}
	
	public void invalidate()
	{	mInvalid=true;
		innerCleanup();
	}
	
	private void innerCleanup()
	{	try
		{	if (mClient!=null && mClient.isConnected())
			{	mClient.disconnect();
			}
		}
		catch (Exception e)
		{	//ignore
		}
	}
	
	public FileTransferClient getClient()
	{	return mClient;
	}
}
