package org.netkernel.client.ftp.util;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

public class PathAndFile
{
	private final boolean mBinaryTransferMode;
	private final String mFileName;
	private final String mDirectory;
	
	private final List<String> mDirectoryPath = new ArrayList<String>();

	public PathAndFile(final String aFilePathAndNameExtended)
	{
		String filePathAndName;

		if (aFilePathAndNameExtended.lastIndexOf(";type=a") != -1)
		{	mBinaryTransferMode = false;
		}
		else
		{	mBinaryTransferMode = true;
		}
		if (aFilePathAndNameExtended.lastIndexOf(";type=") != -1)
		{	filePathAndName = aFilePathAndNameExtended.substring(0, aFilePathAndNameExtended.lastIndexOf(";type="));
		}
		else
		{	filePathAndName = aFilePathAndNameExtended;
		}
		
		int i=filePathAndName.lastIndexOf("/");
		mDirectory=filePathAndName.substring(0,i);

		String[] dirs = filePathAndName.split("/");

		// We know that the first entry is empty because the path -must- start
		// with a "/"
		// And we know that the last entry is the file name
		if (dirs.length == 2)
		{	mFileName = dirs[1];
		}
		else
		{	for (i = 1; i < dirs.length - 1; i++)
			{	mDirectoryPath.add(dirs[i]);
			}
			mFileName = dirs[i];
		}
	}

	/**
	 * Indicates if this file should be transferred as a binary file
	 * 
	 * @return true or false
	 */
	public boolean isBinary()
	{	return mBinaryTransferMode;
	}

	/**
	 * The name of the file to be transferred
	 * 
	 * @return
	 */
	public String getFileName()
	{	return mFileName;
	}
	
	public String getDirectory()
	{	return mDirectory;
	}

	/**
	 * Returns an iterator with a sequence of directories to descend to get to
	 * the requested file.
	 * 
	 * @return
	 */
	public Iterator getDirectoryPath()
	{	return mDirectoryPath.iterator();
	}

}
